<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Symbolic Addresses</TITLE>
<link href="suif1_102.html" rel=Next>
<link href="suif1_100.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_100.html">previous</A>, <A HREF="suif1_102.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC101" HREF="suif1_toc.html#TOC101">Symbolic Addresses</A></H2>
<P>
<A NAME="IDX717"></A>
<A NAME="IDX718"></A>

</P>
<P>
<A NAME="IDX719"></A>
Symbolic addresses are currently only used in immediate values
(see section <A HREF="suif1_100.html#SEC100">Immediate Values</A>).  A symbolic address has two parts, a symbol and an
integer offset.  In many cases, the offset is set to zero, but for an
aggregate data structure the offset may specify the number of bits from
the beginning of the data structure to a particular field.  The
<CODE>sym_addr</CODE> class defined in the <TT>`symaddr.h'</TT> and
<TT>`symaddr.cc'</TT> files implements these symbolic addresses.

</P>
<P>
<A NAME="IDX720"></A>
<A NAME="IDX721"></A>
<A NAME="IDX722"></A>
The <CODE>symbol</CODE> method returns a pointer to the symbol in a symbolic
address, and the <CODE>offset</CODE> method returns the integer offset.  As
with most other offsets in SUIF, the offset is in <EM>bits</EM>.  Be
careful to avoid treating this as a byte or word offset.  As with
immediate values, there are no methods to change the contents of a
symbolic address.  Because these are small structures, it is just as
easy to create new <CODE>sym_addr</CODE> objects whenever they are needed.  To
print a symbolic address, use the <CODE>print</CODE> method.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_100.html">previous</A>, <A HREF="suif1_102.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
